PxHUD = LibStub("AceAddon-3.0"):NewAddon("PxHUD", "AceConsole-3.0", "AceEvent-3.0")

PxHUD.L = LibStub("AceLocale-3.0"):GetLocale("PxHUD", false)

local L = PxHUD.L

local modules = {}
local bEnabled = false

function PxHUD:OnInitialize()
	self.defaults = {
		profile = {
		}
	}
	self.db = LibStub("AceDB-3.0"):New("PxHUDDB", self.defaults)
	self.settings = self.db.profile

	LibStub("AceConfig-3.0"):RegisterOptionsTable("PxHUD", self:GetOptions(), {"pxhud", "px"})
end

function PxHUD:OnEnable()
	bEnabled = true

	for key,value in pairs(modules) do
		if value.OnModuleEnable then
			value:OnModuleEnable()
		end
	end
end

function PxHUD:OnDisable()
	bEnabled = false

	for key,value in pairs(modules) do
		if value.OnModuleDisable then
			value:OnModuleDisable()
		end
	end
end

function PxHUD:GetOptions()
	return {
		name = "PxHUD",
		handler = PxHUD,
		type = "group",
		args = {
			show = {
				type = 'execute',
				name = L["Show options window"],
				desc = L["Shows the PxHUD options window"],
				func = function()
				end,
			},
		},
	}
end

function PxHUD:RegisterModule(module)
	table.insert(modules, module)
	
	if bEnabled then
		module:OnEnable()
	end
end
